import { Observable } from 'rxjs';
export declare function toBoolean(input: null | boolean | string | undefined): boolean;
export declare function unpatchedAnimationFrameTick(): Observable<void>;
export declare function unpatchedMicroTask(): Observable<void>;
export declare function unpatchedScroll(el: EventTarget): Observable<void>;
/**
 * @description
 *
 * calculates the correct scrollTop value in which the rx-virtual-scroll-viewport
 * is actually visible
 */
export declare function parseScrollTopBoundaries(scrollTop: number, offset: number, contentSize: number, containerSize: number): {
    scrollTopWithOutOffset: number;
    scrollTopAfterOffset: number;
    scrollTop: number;
};
/**
 * @description
 *
 * Calculates the visible size of the rx-virtual-scroll-viewport container. It
 * accounts for the fact that the viewport can partially or fully be out of viewport because
 * static contents that are living between the boundaries of rx-virtual-scroll-viewport
 * and its scrollable element.
 */
export declare function calculateVisibleContainerSize(containerSize: number, scrollTopWithOutOffset: number, scrollTopAfterOffset: number): number;
